/*
 * 29/03/2004
 *
 * radiobutton.cpp
 * Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "radiobutton.h"

// ============
// Constructeur
// ============
CRadioButton::CRadioButton(int i, char *label, CRadioGroup *radioGroup) : CWidget(i) {
	m_label = label;
	m_selected = true;
	m_radioGroup = radioGroup;
	
}

// ===========
// Destructeur
// ===========
CRadioButton::~CRadioButton() {

}

void CRadioButton::Mouse(int button, int state, int mx, int my) {
	
	if (m_visible && m_enable) {
	mx = mx - x;
	my = my - y;
	int t = strlen(m_label) * 8 + 22;

	if (mx < t && mx >= 0 && my < 17 && my >= 0)
		if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN) {
			SetSelected(!m_selected);
		mouseClickFunc(id);
		}
	}	
}

void CRadioButton::MouseMotion(int mx, int my) {

}

void CRadioButton::MousePassiveMotion(int mx, int my) {

	if (m_visible && m_enable) {
	mx = mx - x;
	my = my - y;
	int t = strlen(m_label) * 8 + 22;

	if (mx < t && mx >= 0 && my < 17 && my >= 0)
			m_mouseon = 1;
		else m_mouseon = 0;
	}
}

bool CRadioButton::IsSelected() {
	return m_selected;
}

void CRadioButton::Draw() {

	if (m_visible) {
	glPushMatrix();
	glTranslatef(x, y, 0.0f);

	int t = strlen(m_label) * 8;
	
	
	if (m_mouseon) {
	glBegin(GL_QUADS);

	
		glColor3f(0.5, 0.5, 0.5);
	
	glVertex2i(0,0);
	glVertex2i(t+22,0);
	glVertex2i(t+22,17);
	glVertex2i(0,17);

}

	glEnd();

	glTranslatef(3, 4, 0.0f);
	if (m_enable) glColor3f(0.8, 0.8, 0.8); else glColor3f(0.3f, 0.3f, 0.3f);
	drawText(0, 0, "%s", m_label);
	
	glBegin(GL_QUADS);

	glVertex2i(t+6,0);
	glVertex2i(t+16,0);
	glVertex2i(t+16,10);
	glVertex2i(t+6,10);

	glEnd();

	if (m_selected) {

		glDisable(GL_BLEND);
		glColor3f(0.0, 0.0, 0.0);
	
	
	glBegin(GL_QUADS);

	glVertex2i(t+8,2);
	glVertex2i(t+14,2);
	glVertex2i(t+14,8);
	glVertex2i(t+8,8);

	glEnd();
	glEnable(GL_BLEND);


	}

	glPopMatrix();

	}


}

void CRadioButton::SetSelected(bool select) {
	
	if (m_selected == false) {

		if (m_radioGroup != NULL)
		for (int i=0; i<m_radioGroup->GetSize(); i++) {
			m_radioGroup->Get(i)->SetSelected(false);
			
		}
		
		m_selected = select;
	}
	
		
}




