
#ifndef _WIDGET_H
#define _WIDGET_H

#include <cstring>
#include <GL/glut.h>
#include "fontrendering.h"

/*
 * 29/03/2004
 *
 * widget.h
 * Classe Widget
 *
 * Author: Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

class CWidget
{
public:

	// ============
	// Constructeur
	// ============
	CWidget(int id);

	// ===========
	// Destructeur
	// ===========
	~CWidget();

	void virtual Mouse(int button, int state, int mx, int my);
	void virtual MouseMotion(int button, int px, int py, int nx, int ny);
	void virtual MousePassiveMotion(int mx, int my);

	void virtual Draw();

	void OnClick(void (*func)(int i));
	void OnMotion(void (*func)(int i, int x, int y));

	void SetEnable(bool enable);

	void SetVisible(bool visible);

	void SetSelected(bool select);

	int x;
	int y;

	int id;

protected:

	int m_mouseon;

	bool m_enable;

	bool m_visible;

	bool m_selected;
	
	void (*mouseClickFunc)(int i);

	void (*mouseMotionFunc)(int i, int x, int y);
};

#endif



