/*
 * 10/07/2003
 *
 * main.h
 * Fonctions et constantes principales de l'application
 *
 * Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _MAIN_H
#define _MAIN_H

// ====================
// Inclusions standards
// ====================
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <iostream>
#include <time.h>
#include <cave_ogl.h>
#include <GL/glut.h>
#include <unistd.h>

using namespace std;

// ==================
// Windows inclusions
// ==================
#ifdef _WIN32
#include <windows.h>
#pragma comment(lib, "opengl32.lib")		// recherche de OpenGL32.lib pendant l'edition de liens
#pragma comment(lib, "glu32.lib")			// recherche de Glu32.lib pendant l'edition de liens
#pragma comment(lib, "glut32.lib")			// recherche de Glut32.lib pendant l'edition de liens
#define WIN32_LEAN_AND_MEAN
#endif

// =================
// Inclusions persos
//==================
#include "math/math_utils.h"
#include "ogl/glextensions.h"
#include "globals.h"
#include "util/mouse.h"
#include "util/timerGLUT.h"
#include "util/string.h"
#include "imaging/image.h"
#include "imaging/image3D.h"
#include "mygui.h"

// ============================================
// Caracteristiques de la fenetre et de l'ecran
// ============================================
#define WINDOW_WIDTH 640		// largeur de la fentre
#define WINDOW_HEIGHT 480		// largeur de la fentre
#define	WINDOW_POS_X 100		// position x de la fentre
#define WINDOW_POS_Y 100		// position y de la fentre
#define FULLSCREEN_WIDTH 800	// largeur en mode plein cran
#define FULLSCREEN_HEIGHT 600	// hauteur en mode plein cran
#define FULLSCREEN_DEPTH 16		// bit par pixels en mode plen cran

// ==========
// Constantes
// ==========
#define ESC 27			// code ascii de la touche escape

// ==========
// Prototypes
// ==========

// ========================
// Initialisations diverses
// ========================
void init();

// ========================
// Initialisation de OpenGL
// ========================
void initOpenGL(void);

// ================================
// Fonction d'affichage de la scene
// ================================
void caveDisplay(void);

// ===========================================================
// Fonction excut lorsque le programme n'a plus rien  faire
// utilisee pour les animations
// ===========================================================
void caveIdle(void);


#endif

