/*
 * 29/03/2004
 *
 * mygui.h
 * Interface graphique de Visuvo
 *
 * Author: Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef _MYGUI_H
#define _MYGUI_H


#include "globals.h"
#include "gui/gui.h"
#include "gui/transferfunction.h"
#include "gui/button.h"
#include "gui/label.h"
#include "gui/checkbox.h"
#include "gui/radiobutton.h"
#include "gui/radiogroup.h"
#include "imaging/image3D.h"
#include "ogl/glextensions.h"

#define MENU 1

class CMyGui : public CGui
{
public:

	// ============
	// Constructeur
	// ============
	CMyGui(int i, CImage3D *img);

	// ===========
	// Destructeur
	// ===========
	~CMyGui();

	void Draw(int xsize, int ysize);

	void Mouse(int button, int state, int mx, int my);
	void MouseMotion(int button, int px, int py, int nx, int ny);
	void MousePassiveMotion(int mx, int my);

	void OnClick(void (*func)(int i));
	void OnMotion(void (*func)(int i, int x, int y));

	void SetPosition(int x, int y);

	void SetShow(int i);

	CTransferFunction *tf;
	

	CLabel *size;
	CLabel *fps;
	CLabel *mode;

	int show;
};

#endif

