/*
 * 29/03/2004
 *
 * button.h
 * Permet de charger les diffrentes extensions OpenGL ncessaires
 *
 * Author: Thierry Vouriot (Yri)
 * yeri@fr.st
 * http://www.yeri.fr.st
 * thierry.vouriot@free.fr
 * http://thierry.vouriot.free.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */ 

#ifndef _GLEXTENSIONS_H_
#define _GLEXTENSIONS_H_

#include <string.h>

#ifdef _WIN32
#include <windows.h>
#define wglxGetProcAddress wglGetProcAddress
#else
#define GLX_GLXEXT_PROTOTYPES
#include <GL/glx.h>
#define wglxGetProcAddress(a) glXGetProcAddressARB((const GLubyte *) (a))
#endif

#include <GL/gl.h>
#include "glext.h"

// Variables des extensions supportes
extern bool GL_EXT_texture3D_supported;
extern bool GL_EXT_paletted_texture_supported;
extern bool GL_EXT_blend_color_supported;
extern bool GL_EXT_blend_minmax_supported;


// Fonctions GL_EXT_texture3D
extern PFNGLTEXIMAGE3DEXTPROC glTexImage3DEXT;


// Fonctions GL_EXT_paletted_texture
extern PFNGLCOLORTABLEEXTPROC				glColorTableEXT;
extern PFNGLGETCOLORTABLEEXTPROC			glGetColorTableEXT;
extern PFNGLGETCOLORTABLEPARAMETERIVEXTPROC	glGetColorTableParameterivEXT;
extern PFNGLGETCOLORTABLEPARAMETERFVEXTPROC	glGetColorTableParameterfvEXT;


// Fonctions GL_EXT_blend_color
extern PFNGLBLENDCOLOREXTPROC glBlendColorEXT;

// Fonctions GL_EXT_blend_minmax
extern PFNGLBLENDEQUATIONEXTPROC glBlendEquationEXT;


// -------------------------------------------------------------------------

bool findExtension(char *extensions, char *extension);

#define isExtensionSupported(str)     (findExtension(extensions,     str))

void initExtensions(void);


#endif // _GLEXTENSIONS_H_
